Overview: SwarMala Accompaniment

SwarMala Accompaniment has been developed with the needs of a performing Indian musician in mind. SwarMala Accompaniment can act as your own personal accompanist on Tabla, Harmonium, Tanpura (drones) or any other instrument supported by SwarMala framework. The key features of SwarMala Accompaniment are:

  • Simple design with minimal and essential navigation controls for most basic needs
  • Intuitive and friendly Windows graphical user interface
  • Three independent channels for accompaniment using (possibly different) instruments simultaneously
  • Independent volume controls for each channel, and independent tempo controls for Tanpura and Melody/Percussion channels
  • Ability to automatically change the tempo after a specified number of rhythm cycles
  • Automatic beat synchronization of melody and percussion channels
  • Display of current beat number (matra) and rhythm cycle (Aavartan) number
  • Ability to save your accompaniment settings for easy retrieval later
  • An extensive library of accompaniment tracks (including hundreds of Tabla taals and Lehras, to begin with)


Overview: SwarMala Composer

SwarMala Composer is a full-featured sequencer application supporting several Indian instruments. Although SwarMala Composer has been developed with typical needs of an Indian musician, it can be used for composing any music. The key features of SwarMala Composer are:

  • Intuitive, friendly and familiar Windows user interface
  • Sound banks for several Indian instruments, with high quality sounds recorded by well-known artists. The instruments included with SwarMala are: Harmonium, Sarod, Sitar, Bansuri (Bamboo flute), Santoor, Shahnai, Sundree, Tabla, Pakhawaj, Dholaki and Tanpura (drones)
  • Ability to add your own instrument(s) to SwarMala for composition
  • Full featured multi-track sequencer for easy composition
  • Built-in sampler, which allows playing SwarMala instruments from an external keyboard/MIDI device
  • Record MIDI from external keyboard
  • An extensive library of typically used musical parts which can be used as the basic framework to compose your music
  • Ability to export SwarMala compositions as a standard MIDI format file
  • Ability to set the desired rhythm cycle (taal) for easy-to-read display
  • Optional reverb sound


Using SwarMala Composer

Understanding SwarMala views

Understanding various composition views is key to composing good music using SwarMala Composer.

  • Information View
  • Sequencer View
  • Piano Roll View
  • Composer (Music Part) View

Creating compositions

This section describes various topics related to creating new compositions, editing existing SwarMala compositions, audio playback and file formats.

  • Adding tracks, music parts and notes
  • Adjusting track properties
  • Resolution of the composition elements (ticks per beat and beats per measure)
  • Various track properties: mode, channel, instrument
  • Importing pre-composed music parts
  • Putting it all together

Playing

  • All tracks
  • Selective tracks
  • Single track
  • Viewing current play position

MIDI and SwarMala

  • Using SwarMala Sampler and playing SwarMala instruments from an external keyboard/MIDI device
  • MIDI Key Mapping for Various Instruments

Navigating through the Composition

  • Positioning the cursor
  • Using markers
  • Positioning the loop points
  • Finding notes

Saving Compositions

  • As multi-track SwarMala Music Composition (*.swr)
  • As single SwarMala music part (*.smp)
  • As standard MIDI file
  • As standard WAV format file


Information View

The information view for a SwarMala composition displays the global properties of the composition. Following properties are accessible from the information view:

  • Composition name
  • Author (Composer)
  • Company affiliation of the Author (Composer)
  • Copyright information (if any) for the composition
  • Main tempo (default) of the Composition: This is the tempo (in beats per minute) at which the composition is automatically played at, unless the main tempo is explicitly changed form the SwarMala main window. The main tempo of SwarMala will be automatically set to this value whenever this file is opened.
  • Tanpura Tempo (default) of the Composition: This is the tempo (in beats per minute) of the Tanpura (drones) track of the composition (if any are present). Note that the drones tempo can be different from the main tempo, as typically drones track and main melody/percussion tracks are not tempo synchronized. Drones (Tanpura) tempo defines the speed at which the strings of a Tanpura are strummed, which is (usually) independent of the main song's tempo.
  • Taal (time signature) of the composition: Time signature of the composition is specified here. The default time signature for all new compositions in SwarMala is 4/4 (4 beats per measure, 4 quarter notes per beat). A composer can change the number of beats per measure by selecting most frequently used time signatures from the choices, or by specifying a custom time signature. For example, to use a 12/4 time signature, simply choose Ektaal (12) from the drop-down list. To specify beats per measure other than those in the drop-down list, enclose them in parentheses. For example, to specify 13 beats per measure (a choice not present in the drop-down list), enter "MyTaal (13)" in the Taal (Beats per cycle) box (without the quotes and specifying any name instead of MyTaal, if required), and hit the enter key. All open views will be updated to reflect the newly selected rhythm cycle (beats per measure).
  • Key (Scale): Specifies the base Sa for the composition. This is equivalent to the scale. This information is used to calculate appropriate transposition setting in SwarMala Accompaniment when the composition is played at a different scale (transposed).
  • Notes: Any other notes relating to the composition.


Sequencer View

Sequencer view shows the full composition at a glance. It displays tracks in the composition and their properties. The currently selected track is displayed in gray color.

Various properties of the tracks can be adjusted from the sequencer view. These include:

  • Track Name
  • Channel: Midi channel for the track
  • Mode: Mode of the track can be selected as either melody, percussion or drones. Each mode has differnt instrument (the selection in "Instrument" column depends on the "Mode" column).
  • Instrument: Instrument for the track
  • Mute: Checking the mute checkbox [image] prevents the corresponding track from playing
  • Solo: Checking the solo checkbox [image] mutes all the tracks other than the selected track, so that only the current track is played
  • Key+: The track is transposed up (+ value) or (- value) by number of semitones specified in this property

The screenshot below displays the sequencer view of a three track composition, consisting of one lead (melody) track on Hamonium, an accompaniment (percussion) track on Tabla and an accompaniment (drones) track on Tanpura. The composition is set to Tritaal (a rhythm cycle of 16 beats), with loop points set at the beginning and end of the first measure.


Piano Roll View

Piano Roll View is used for composing music parts and tracks. The piano roll view shows notes in the currently selected track. The track number is shown in the top left corner, and standard piano/keyboard keys are shown in the left pane. The piano/keyboard spans a little over 10.5 octaves (128 notes), which is the range of standard MIDI keyboard. The keys are labeled as C0, C#0, D0, D#0, ... etc, with the first one or two letters corresponding to the name of the note (C, C#, D, D#, E, F, F#, G, G#, A, A#, B) and the last digit indicating the octave. The middle C (Madhya Saptak White 1 on Harmonium) is mapped to note C5 in the piano view, for most instruments. The MIDI key mapping for all instruments is given here for reference.

The piano view shows a horizontal and a vertical cursor. The vertical cursor is the current music time (which can be precisely read from the main window's audio control toolbar as shown below).

The horizontal cursor, shown in beige [image] color, shows the current piano key selected. The menu "Note - Add" will insert a note with this key at the current cursor position.

An alternative (and easier) method of adding notes to the track is by holding down the Ctrl key on the keyboard while clicking on the piano view.

By default, all notes added to the piano view have duration of exactly 1 beat. The default duration setting can be changed via menu "Tools - Options".

Clicking on the piano view plays the current note on the currently selected instrument.

The properties of each individual note can be adjusted via the Note Properties dialog, which can be accessed via menu "Note - Note Properties", or by double-clicking on the note. The velocity (relative volume) of the note is proportional to the height of the displayed rectangle, which can be dragged up or down to change the velocity.

The notes belonging to a single music part are displayed in the piano view with the same color. Maximum 8 colors are used. Therefore, if you have more than 8 music parts in a track, the colors assigned to the notes of first and 9th music part will be the same.

The screenshot below shows the piano view of a track with single music part.


Composer (Music Part) View

Composer View

The composer view shows the music parts contained in the currently selected track. The constituent music parts are shown in different colors, in two rows, in the right hand pane of the view window. The top row shows the music parts that have been imported from external files. The bottom row shows the "Default" music part, which consists of notes added to the track via the piano roll view. The default music part always starts at time 01:01:000 regardless of the starting time of the first note. Also it'sstart time cannot be modified.

The imported music parts (those shown in the upper row of the Composer View) can be dragged to adjust their properties. Dragging a music part's boundary stretches or shrinks the part with all the notes in the part stretched or shunk in the same proportion.

The left panel of the Composer View displays the list of *smp and *.swr files in the folder shown. Double-clickng on any of the items in this list imports the corresponding music part from the file into the current track, and inserts it at the current cursor position.

The name and start time of the currently selected music part can be changed by double-clicking on it at the bottom the view.

The "Set Folder" button [image] in the left pane can be used to change the default folder location of the music parts library.

The following screenshot displays the Composer View of a track with single (default) music part.


Tracks

Track Composition

A track is the basic element of a SwarMala Composition. Each track consists of music parts and/or notes. All tracks in the composition and their properties are displayed in the Sequencer View.

Adding and Deleting Tracks

To add a new track to the composition, use "Track - New" menu. The new track is added at the current track position in the Sequencer View. The default track mode is always "Melody" with instrument "Harmonium". The MIDI channel assigned to the new track is the next available MIDI channel number such that it does not conflict with the channel numbers assigned to the current tracks. To delete an existing track, press Delete key in the Sequencer View or use the menu "Track - Delete".

Adjusting Track Properties

Various track properties are accessible via the "Track" menus "Transpose" (transposes the selected track by specified number of semitones), "Slide" (time-slide the selected track), "Stretch" (time-stretch or time-shrink the selected track), "Velocity" (adjust the volume of all notes in the selected track).

Other properties of the selected track can be viewed and edited via the menu "Track - Properties" or from the Sequencer View. These include:

  • Track Name
  • Channel: Midi channel for the track
  • Mode: Mode of the track can be selected as either melody, percussion or drones. Each mode has differnt instrument (the selection in "Instrument" column depends on the "Mode" column).
  • Instrument: Instrument for the track
  • Track Volume: Relative volume of the track
  • Mute: Checking the mute checkbox [image] prevents the corresponding track from playing
  • Solo: Checking the solo checkbox [image] mutes all the tracks other than the selected track, so that only the current track is played
  • Key+: The track is transposed up (+ value) or (- value) by number of semitones specified in this property


Music Parts

A music part is an element in the SwarMala composition and contains a set of notes with a given time relationship. Music parts are saved in SwarMala files with an extension SMP (SwarMala Music Part), and can be opened and edited similar to the SwarMala composition files. A music part can be a simple piece of music in a composition, or as complicated as a complete melody track. SwarMala Composer has its own extensive music parts library consisting of many pre-composed music parts upon which you can build your own music. The default location of the pre-composed music parts library is %InstallFolder%\Pre-composed Tracks\ (Replace "%InstallFolder%" with the installation path for SwarMala, which is "C:\Program Files\SwarMala" by default). You can change his path by Using the "Set Folder" button [image] in the left panel of the Composer View

Adding and Deleting Music Parts

To add a pre-composed music part from the music parts library, position the cursor at the desired point, and double-click on the desired music part in the left pane of the Composer View. The selected music part will be added and merged with the current track, at the current cursor position. If the instrument of the music part does not match with the instrument of the current track, SwarMala will warn you before importing the music part. You can also import the SwarMala Composition (*.swr) files using this method; however, only the first track of the *.swr file will be imported and merged with the current track.

The second method of importing music part to a composition is via menu "Music Part - Insert from File", where you can select a specific file containing the desired music part (an SWR or SMP file).

Once the music part has been imported, it is displayed in the Composer View and its notes are displayed in the Piano View.

Adjusting Music Part Properties

Various properties of the music parts are accessible via the "Music Part" menus "Transpose" (transposes the selected music part by specified number of semitones), "Slide" (time-slide the selected music part), "Stretch" (time-stretch or time-shrink the selected music part), "Velocity" (adjust the volume of all notes in the selected music part). The name and the start-time of the music part can also be adjusted from the Composer View for precise adjustment.


Notes

Notes are the fundamental element of the composition. All music parts and tracks consist of notes. Following properties of the note can be adjusted from the Note Properties window (accessible via menu "Note - Properties" or by double-clicking on the desired note in Piano Roll View). The note properties window looks as follows:

Adjusting Note Properties

  • Note/Bol Name: This is a character string used to identify the given note. The box shows various choices (depending upon the chosen instrument), from which you can select the desired note or provide your own name.
  • Midi Key: Midi key is the position of this note on the Piano Roll. For most melody instruments, the Midi key directly maps to the corresponding note. For percussion instruments, however, the mapping is not straightforward. The MIDI key mapping for all SwarMala instruments can be found here.
  • Velocity: This defines the MIDI velocity (relative volume) of the note as an integer between 0 and 127.
  • Start time and End time: Start time and end time are given in mm:bb:ttt (measures, beats, ticks) format.
  • Pitch Bend (Meend): An important feature of SwarMala is ability to set pitch bending on a note. The parameters for pitch bending are set in the "Pitch Bend" section of the note properties dialog. The shape of the pitch bend curve can also be set. The range of pitch bending is limited to +/- 2 semitones from the current note.
  • Pitch Bend Start time and Pitch Bend End time


Creating Compositions: Putting it All Together

Procedure for Creating a Composition

SwarMala uses a modular approach to composing music by putting together music parts and notes to form tracks. This approach helps in creating a re-usable music parts that can be used for other purposes. Therefore, before constructing a SwarMala composition, it is always a good idea to take a moment and think about the individual musical building blocks that constitute each track. Compose each of these building blocks as a separate music part, and save them to files. Finally, put the desired music parts together to build a complete track.


Measures, Beats and Ticks

SwarMala uses the standard terminology of measures, beats and ticks for describing the musical timing relationships within the composition. The time signature (Taal or rhythm cycle) for the composition is set via the Information View.

A measure is equivalent to a complete rhythm cycle (Aavartan of a Taal in Indian music terminology). A measure can contain one or more (an integer number) of beats, and is set via the Information View. Measures are counted starting from 1.

A beat is equivalent to the basic tempo tap (equivalent to a single Matra in Indian music terminology). Each beat consists of 768 ticks (resolution) in SwarMala. Beats are counted starting from 1. For example, a composition with 16 beat rhythm cycle (equivalent to a Trital in Indian music) with consist of 16 beats per measure in its time signature.

A tick is the smallest time with which music time can be resolved. Each beat in SwarMala consists of 768 ticks. This is a pre-defined (fixed) number, which cannot be changed. In other words, all SwarMala compositions have a fixed resolution of 768 ticks per beat (tpb).

Specifying Time as mm:bb:ttt

All the timings in SwarMala are notated in mm:bb:ttt format, where mm is the measure number, bb is the beat number and ttt is the tick number of the current time. For example, time 03:11:192 with Ektaal (12) as the selected Taal (a 12-beats per measure time signature) indicates time within the third measure (third rhythm cycle or Aavartan), with quarter (768/4 = 192) of 11th beat (11th matra) already elapsed. As another example, time 02:9:576 with Matta Taal (9) as the selected Taal (a 9-beats per measure time signature) indicates time within the second measure (second rhythm cycle or Aavartan), with three quarters (768 * 3/4 = 576) of 9th beat (9th matra) already elapsed.


Audio Playback

Audio playback is controlled via the menu "Audio". To play the active composition from current cursor position, use "Play" [image] menu. To play the composition from beginning, use "Play from Beginning" [image] menu. To loop the composition from current position or from beginning,, use "Loop" [image] and "Loop from Beginning" [image] menus, respectively.

Playing All tracks

To play all tracks, ensure that all tracks are unmuted. The tracks can be muted or unmuted individually via the "Mute" column check boxes in the Sequencer View.

Selective tracks

To play only selected tracks, selectively mute and unmute the desired tracks via the "Mute" column check boxes in Sequencer View.

Single track

To play a single track, mute all the tracks except the one to be played. Alternatively, you can set the "Solo" property of the track, which will automatically mute all other tracks. Both "Mute" and "Solo" properties are accessible via the Sequencer View.

Mute and Solo Properties in the Sequencer View

Viewing current play position

The current cursor position (and play position) is displayed in the main audio toolbar as mm:bb:ttt (mm = measures, bb = beats, ttt = ticks). To view the play position in a larger window, use "View - Play Position" menu.

Setting Loop Points

By default, when you select "Loop" or "Loop from Beginning" menu, the loop begin point is set to 0 and the loop end point is set to the lowest measure boundary following the end of the last event in the composition. However, you can select the desired loop start and end points via menu "Audio - Set Loop Points" or by dragging the loop points in Sequencer View, Piano View or Composer View. The loop begin and end points are shown by a pair of orange dashed lines as shown below (shown for a Sequencer View). More details on setting the loop points and navigating through the composition can be found here.


Audio Control

The main audio control bar shown above is used for controlling the global audio properties for the playback. The main elements of the audio control bar are as follows:

  • Main tempo: This is the master tempo (in beats per minute) of playback.
  • Tanpura tempo: This is the tempo (in beats per minute) of the Tanpura (drones) track of the composition (if any are present). Note that the drones tempo can be different from the main tempo, as typically drones track and main melody/percussion tracks are not synchronized. Drones (Tanpura) tempo defines the speed at which the strings of a Tanpura are strummed, which is (usually) independent of the main song's tempo.
  • Volume: Controls the master volume of the audio output (range 0 to 127). The relative volume of each track can be controlled via the Track Properties in Sequencer View or via the Track Properties Window (accessible from menu Track - Properties).
  • Position: Shows current cursor position (or current play position) in mm:bb:ttt format.
  • Input Port: Displays the currently selected MIDI input port/device. See MIDI Capture and SwarMala Sampler for more details.


Navigating Through the Composition

Positioning the cursor

To position the cursor at a desired point in music time, simply click in any view. To position the cursor precisely at a desired music time, enter the time in the Position box on the main audio control bar. To navigate toe the next/previous, neasrest beat (matra) or measure (Aavartan) boundary, use various menus under the main manu Go.

Using Markers for Navigation

To "bookmark" a particular point in the composition, you can insert a marker at that point using the menu "Tools - Insert Marker". The markers are saved along with the composition to the .swr or .smp file. To re-position the cursor at the desired point, simply use the marker sub-menus under the main menu Go.

Positioning the Loop Points

The loop points of the composition are shwon by dashed orange lines as shown below (for the Sequencer View). If the loop points are not set by the composer, they are set automatically by the loop setting default algorithm (at 0 and the next measure boundary).

To set non-default loop points, simply drag the loop point cursors to the desired music time points. Precise adjustments are possible via the loop points dialog as shown below (accessed by menu "Audio - Set Loop Points" or by double-clicking on the loop point cursor).

Finding Notes

The menus "Edit - Search" and "Edit - Search Again" can be used to construct powerful searches through the selected track to find a particular note. This feature is particularly useful when something in the track is not sounding right to the ear, and you are able to make it out audibly, but not visually (not visible within the track). If you know any property of the note (e.g. MIDI key), you can use the Search feature to find the particular note and fix it. All parameters in this dialog (except the MIDI key) are optional.


File Formats

SwarMala File Formats

SwarMala currently supports the following file formats:

  • SwarMala Composition (*.swr): This is the native SwarMala composition file format and is the default format when saving the files (unless the user chooses a different format). This file format can be used to store all kinds of SwarMala compositions (single and multi-track).
  • SwarMala Music Part (*.smp): This is the preferred file format for saving individual music parts.
  • Standard MIDI Format (*.mid, *.midi, *.smf): SwarMala can export the composition as a type 2 (multi-track) standard MIDI file. The MIDI file so exported consists of n + 1 tracks where n is the number of tracks in the SwarMala composition. The first track of the exported MIDI file simply contains the time signature information, tempo and other information about the composition (title, author, copyright etc). The music data is present in tracks 2 through n + 1. Each music track (2 through n + 1) of the exported MIDI file starts with following three events:
    • Bank Select MSB
    • Bank Select LSB
    • Program (patch) change
      • This is followed by note on/off events and (possibly) pitch bend events (if pitch bending is enabled on any notes). Note that currently, SwarMala can only export standard MIDI files, but cannot read (import) from them. Therefore, it's always recommended that you keep a copy of the composition in one of the native SwarMala file formats (*.swr or *.smp). A set of very useful MIDI utilities is available on the Internet at the following web site: http://www.borg.com/~jglatt/progs/software.htm
  • Standard WAV Format (*.wav): SwarMala can export the entire composition as a single WAV format file. Use the menu File - Export Audio (Ctrl + E) to export the entire composition as a standard WAV format file. Alternatively, you can also export a single track as a WAV file. To export a single track, select the desired track in the Sequencer View and use menu File - Export Track Audio (Ctrl + D). In either case, SwarMala plays the entire composition while exporting the audio as a WAV file. It is recommended that you do not perform any other operation while the audio export is in progress.


File and Folder Settings

Following folder are used by SwarMala software internally. The files in these folders should never be modified by the user. In following discussion, %InstallFolder% refers to the path where SwarMala software is installed on your computer (C:\Program Files\SwarMala by default).

  • %InstallFolder%\DLS: This folder contains all DLS (downloadable sound) collection files used by SwarMala. Any DLS collection files for user-defined instruments should also be stored to this folder. The DLS collection files have an extension .dls. Apart from DLS collection files, this file also contains following files.
    • SwarMala.ins: User-defined instrument definitions
    • *.swm: These text files contain friendly names for keyboard mapped sounds of various instruments. For example, Tabla.swm contains names of various Tabla bols and their mapping onto the MIDI keyboard.
  • %InstallFolder%\Pre-composed Tracks: This folder should be used to save any music parts that you wish to re-use. The pre-composed music parts library files supplied with SwarMala are located in this folder, within subdirectories for each instrument.


MIDI Key Mapping for SwarMala Instruments

Various instruments in SwarMala are mapped on to the MIDI keyboard (128-key) as given in the following maps. Click on each instrument to see its MIDI key map.

See also: Using SwarMala Sampler and playing SwarMala instruments from an external keyboard/MIDI device

Drone Instruments

  • Tamboura (patch 10)
  • Tanpura (patch 11)

Melody Instruments

  • Harmonium (patch 12)
  • Sarod (patch 13)
  • Santoor (patch 14)
  • Shahnai (patch 15)
  • Sundree (patch 16)
  • Sitar (patch 17)
  • Bansuri (Bamboo flute) (patch 18)
  • Acoustic Guitar (Mohan Veena) (patch 19)

Percussion Instruments

  • Tabla (patch 20)
  • Pakhawaj (patch 21)
  • Dholaki (patch 22)
  • Jhanj/Manjeera (Bells) (patch 23)


SwarMala Sampler

SwarMala sampler can be used to connect standard MIDI devices to SwarMala through your computer's MIDI input port, and play/record using the SwarMala instruments. An example setup would be as shown in the following figure.

In the setup shown above, the composition in SwarMala Composer has four tracks, with Sitar on MIDI channel 1, Sarod on MIDI channel 2, Tabla on MIDI channel 3, and Tanpura on MIDI channel 4. Further, an external MIDI keyboard is connected to the input port of the computer via a MIDI connector. Any keys played on the keyboard will be transmitted to SwarMala via MIDI messages. For example, one can play Sarod by sending note ON/OFF messages via the keyboard on MIDI channel 2, or Tanpura by sending note ON/OFF messages on MICI channel 4 etc.

Warning: SwarMala sampler currently does not understand the MIDI program change (patch change) messages, and as such, if a program change message is sent via the keyboard, the behavior is unpredictable. Use the instrument selector in the SwarMala Sequencer View to set the desired instrument on a channel.

To use SwarMala sampler, you need not have an external keyboard. You can play using a software keyboard with MIDI capability. One such excellent software keyboard available on the Internet is Bome's Mouse Keyboard. You will also need MIDI Yoke virtual MIDI cable to connect the Bome's keyboard to SwarMala.

Disclaimer: Bome's Mouse Keyboard and MIDI Yoke are third party products and are not related to SwarMala or TaalMala in any way. As such, you are bound by ther respective license agreements and legal rights of the respective software. The links are provided here just for your convenience.

A possible setup using software keyboard, virtual MIDI cables, and SwarMala can be as shown below:


Recording/MIDI Capture

MIDI Capture/Recording

SwarMala Composer can be used to record a melody being played via an external keyboard. To record from a MIDI keyboard, follow these steps:

  • Connect the external keyboard to the PC via its MIDI input port (see Using SwarMala Sampler) and select the appropriate MIDI input port in SwarMala.
  • Select the track to be recorded.
  • Select appropriate mode and the instrument to be played on the track
  • Play on the external keyboard to ensure that appropriate instrument is selected by SwarMala
  • Use Record [image], Play and Record [image], or Loop and Record [image] buttons to capture from the MIDI keyboard.

    • See also: SwarMala Sampler


Working with Instruments

Various instruments and their MIDI patch numbers

The following table shows various instruments used by SwarMala and their MIDI patch numbers.

Instrument | MSB | LSB | Patch
Tamboura (drones) | 110 | 0 | 10
Tanpura (drones) | 110 | 0 | 11
Harmonium | 110 | 0 | 12
Sarod | 110 | 0 | 13
Santoor | 110 | 0 | 14
Shahnai | 110 | 0 | 15
Sundree | 110 | 0 | 16
Sitar | 110 | 0 | 17
Bansuri | 110 | 0 | 18
Acoustic Guitar | 110 | 0 | 19
Tabla | 110 | 0 | 20
Pakhawaj | 110 | 0 | 21
Dholaki | 110 | 0 | 22
Jhanj (Manjeera) | 110 | 0 | 23

The MIDI key mappings for all instruments are shown here.

Adding your own instrument(s) to SwarMala and composition using custom instruments

You can record your own instrument sounds and use them in SwarMala Composer. Once you have the desired sounds, you need to create a DLS (Downloadable Synthesizer Sound) file using the recorded sounds. You can use the tool such as Microsoft DirectMusic Producer for creating a DLS file. Please refer to the DirectMusic Producer help for instructions on how to create a DLS file from the sounds. Please ensure that the MIDI patch number used for your instrument is greater than 110.

Once you have created a DLS file, copy the DLS file to the folder named "DLS" under the SwarMala installation directory (C:\Program Files\SwarMala by default). From SwarMala Composer, go to menu "Tools - Add instrument", enter the details of the instrument (including MSB, LSB and patch number assigned to the instrument in the DLS file above), select the instrument's mode (percussion, melody or drones), and click on OK. The new instrument will now be available for composition in the Instrument column of the Sequencer View.

It is also recommended that you create a .swm file for the instrument. This file contains the mapping of sounds on the MIDI keyboard and their user-friendly names. For example, please look at the file %InstallFolder%\DLS\Tabla.swm, where %InstallFolder% is the SwarMala software installation folder (C:\Program FIles\SwarMala by default).


Understanding Channels

SwarMala Accompaniment Channels

SwarMala Accompaniment software provides three independent channels of accompaniment. In other words, you can play three independent compositions simultaneously. For a typical Indian classical music accompaniment, one would use one channel in percussion mode, second in drones (Tanpura) mode and third in melody mode (if needed). The three accompaniment channels are laid out horizontally within the main SwarMala Accompaniment window.

The composition to be played on each accompaniment channel is individually selectable from the channel controls.

All percussion and melody mode channels are synchronized with respect to tempo and starting point. The drones (Tanpura) channel has its own independent tempo setting, which controls the speed at which the strings of the Tanpura are strummed. The Tanpura tempo is different from the main melody/percussion tempo since usually it is independent of the main song's tempo.

Each channel in SwarMala Accompaniment can be independently enabled or disabled. Volume of each channel can be increased or decreased relative to those of other channels.

The display panel at the rightmost end of each channel shows the details of the composition selected to be played on that channel.

Following screenshot shows a single SwarMala Accompaniment channel, set to play Tanpura (drones) pattern Pa Sa Sa Sa.


Tempo, Volume and Scale Control

Controlling Volume

Each accompaniment channel has an independent volume control (in the range of 0 to 127) [image], which can be modified independently. The master volume is controlled via the main volume slider control in the top left corner of the main window.

Controlling Tempo

The main tempo controls are located in the at the top of the main window.

The tempo can be precisely adjusted by entering a value in the edit box (in beats per minute). The main tempo controls the tempo of all channels that are set to play in percussion or melody mode. The drones (Tanpura) channels have independent per-channel tempo setting.

In addition to the main tempo, the drones (Tanpura) channels have their independent tempo setting. and it controls the speed at which the strings of the Tanpura are strummed. The Tanpura tempo is different from the main melody/percussion tempo since (usually) it is independent of the main song's tempo. If more than one channel is set to play drones (Tanpura), only one of the drones channel shows the independent tempo control and this tempo setting is used by all the drones (Tanpura) channels.

Auto-increment/Auto-decrement

The main tempo can be set to automatically increase or decrease by give namount (in bpm) after a specified number of rhythm cycles (Taal Aavartans). Use the corresponding controls shown in the screenshot above to control this feature. To disable auto-increment/decrement, simply enter 0 in any of the auto-increment/decrement controls.

Setting the Accompaniment Scale

The scale of the melody can be set by selecting from the scale box in the main controls window.

The composition selected on all channels is transposed up or down by appropriate number of semitones, depending upon the base scale authored into the composition, when the composition was authored in SwarMala Composer. For example, if the base scale (authored into the composition) of the composition playing on channel 1 is D#5, and you select C# as the scale in SwarMala Accompaniment scale control above, the composition will be transposed down by 2 semitones (D# - C# = 2 semitones) before being played.


Saving Accompaniment Settings

Saving and Retrieving Accompaniment Settings

You can save the settings used in SwarMala Accompaniment for easy retrieval later. Simply save the current accompaniment settings to .sma file using the menu "File - Save Settings".

To reload the previously saved settings, use menu "File - Open Settings" and select the appropriate .sma file containing the settings.


Important Definitions

Following terms are used in SwarMala Composer and SwarMala Accompaniment

  • Measures, beats and ticks
  • MIDI mapping for SwarMala Instruments
  • Music parts
  • Notes
  • Main tempo and Tanpura tempo
  • Info View
  • Composer (Music Part) View
  • Piano Roll View
  • Sequencer View


SwarMala Composer Overview

SwarMala Help

SwarMala is a complete software package for Indian music composition and accompaniment, and consists of two main components:

SwarMala Composer

  • Overview
  • Using SwarMala Composer
  • Working with Instruments
  • MIDI Key Mapping for Various Instruments
  • SwarMala Sampler
  • Playing
  • Recording/MIDI Capture
  • Saving Compositions and Exporting as standard MIDI or WAV format files
  • File and Folder Settings
  • Audio Properties
  • Important Definitions

SwarMala Accompaniment

  • Overview
  • Understanding Channels
  • Controlling Tempo, Volume and Scale (Key)
  • Saving Accompaniment


MIDI Key Mapping

MIDI Key Map for Bansuri (patch 18)

The following figure shows the mapping of various Bansuri sounds onto the MIDI keyboard. The MIDI keys ranging from C0 through C8 have been mapped to the Bansuri sounds.

The lower keyboard (C0 through C4) is mapped to the fast-blown sounds (with high attack characteristics - sometimes called "Tu Ku" modulation in Bansuri terminology).

The middle part of the keyboard (C#4 through C8) is mapped to normal blown sonds.

The rest of the MIDI keyboard (not shown in the figure below) is not mapped to any sounds.

MIDI Key Map for Bansuri
MIDI keys from C0 through C8


MIDI Key Mapping

MIDI Key Map for Dholaki (patch 22)

The following figure shows the mapping of various Dholaki bols onto the MIDI keyboard. The pitched bols (whose sound is pitch-dependent) have been mapped to an entire octave (e.g. Bol Na is mapped from G#4 through G5, corresponding to Dholakis of different pitch - The main Dholaki pitch is G# (K4)). The bols that do not have pitch (e.g. Ge) are mapped to the higher portion of the MIDI keyboard.

MIDI Key Map for Dholaki
MIDI keys C0 through G6 | MIDI keys G#7 through G10


MIDI Key Mapping

MIDI Key Map for Acoustic Guitar (Mohan Veena) (patch 19)

The entire MIDI keyboard (C0 through G10) is mapped onto the open plucked string strokes of an Acoustic Guitar (Mohan Veena).


MIDI Key Mapping

MIDI Key Map for Harmonium (patch 12)

The entire MIDI keyboard (C0 through G10) is mapped onto the Harmonium sounds. The middle C is mapped onto C5.


MIDI Key Mapping

MIDI Key Map for Jhanj/Manjeera (Bells) (patch 23)

The following figure shows the mapping of various Jhanj/Manjeera (Bells) sounds onto the MIDI keyboard.

The MIDI key range C#4 through C5 is mapped to normal open stroke.

The MIDI key range C#5 through C6 is mapped to open stroke, with sustain.

The MIDI key range C#6 through C7 is mapped to closed stroke.

The rest of the MIDI keyboard (not shown in the figure below) is not mapped to any sounds.

MIDI Key Map for Jhanj/Manjeera (Bells)
MIDI keys C#4 through C#7


MIDI Key Mapping

MIDI Key Map for Pakhawaj (patch 21)

The following figure shows the mapping of various Pakhawaj bols onto the MIDI keyboard. The pitched bols (whose sound is pitch-dependent) have been mapped to an entire octave (e.g. Bol Na is mapped from G#4 through G5, corresponding to Pakhawaj's of different pitches). The bols that do not have pitch (e.g. Ge) are mapped to the higher portion of the MIDI keyboard.

MIDI Key Map for Pakhawaj
MIDI keys C0 through G7 | MIDI keys G#7 through G10


MIDI Key Mapping

MIDI Key Map for Santoor (patch 14)

The following figure shows the mapping of various Santoor sounds onto the MIDI keyboard. The single stroke sounds are mapped onto the middle portion of the MIDI keyboard from G#3 through F7 (with C5 corresponding to middle C - Madhya Saptak C).

Double stroke sounds are mapped onto the lower portion of the MIDI keyboard (from C0 through G3), whereas sustained multiple stroke sounds are mapped onto the higher portion of the keyboard from F#7 through G10.

MIDI Key Map for Santoor
MIDI keys C0 through F7 | MIDI keys F#7 through G10


MIDI Key Mapping

MIDI Key Map for Sarod (patch 13)

The following figure shows the mapping of various Sarod sounds onto the MIDI keyboard. The sounds with Ra (down stroke) are mapped onto the keyboard from C0 through G3 (3.5 octaves). The sounds with Da (up stroke) are mapped onto the keyboard from G#3 through G7 (4 octaves).

The Jhala string is mapped onto the keyboard from G#7 through G8 (1 octave).

The resonating strings (taraf) are mapped onto the MIDI keyboard from G#8 through G10 (2 octaves).

MIDI Key Map for Sarod
MIDI keys C0 through G7 | MIDI keys G#7 through G10


MIDI Key Mapping

MIDI Key Map for Shahnai (patch 15)

The following figure shows the mapping of various Shahnai sounds onto the MIDI keyboard. The MIDI keys ranging from C#4 through C#8 have been mapped to the Shahnai sounds.

The rest of the MIDI keyboard (not shown in the figure below) is not mapped to any sounds.

MIDI Key Map for Shahnai
MIDI keys from C#4 through C#8


MIDI Key Mapping

MIDI Key Map for Sitar (patch 17)

The following figure shows the mapping of various Sitar sounds onto the MIDI keyboard. Normal single strokes are mapped onto the keyboard from MIDI keys G#3 through G7 (4 octaves), with C5 corresponding to the middle C

The Jhala string is mapped onto the keyboard from G#7 through G8 (1 octave).

The resonating strings (taraf) are mapped onto the MIDI keyboard from G#8 through G10 (2 octaves).

MIDI Key Map for Sitar
MIDI keys G#3 through G7 | MIDI keys G#7 through G10


MIDI Key Mapping

MIDI Key Map for Sundree (patch 16)

The following figure shows the mapping of various Sundree sounds onto the MIDI keyboard. The MIDI keys ranging from C#4 through C#7 have been mapped to the Sundree sounds.

The rest of the MIDI keyboard (not shown in the figure below) is not mapped to any sounds.

MIDI Key Map for Sundree
MIDI keys from C#4 through C#7


MIDI Key Mapping

MIDI Key Map for Tabla (patch 20)

The following figure shows the mapping of various Tabla bols onto the MIDI keyboard. The pitched bols (whose sound is pitch-dependent) have been mapped to an entire octave (e.g. Bol Na is mapped from G#4 through G5, corresponding to Tablas of different pitch). The bols that do not have pitch (e.g. Ge) are mapped to the higher portion of the MIDI keyboard.

MIDI Key Map for Tabla
MIDI keys C0 through G7 | MIDI keys G#7 through G10


MIDI Key Mapping

MIDI Key Map for Tamboura (patch 10)

The following figure shows the mapping of various Tamboura sounds onto the MIDI keyboard. The sounds corresponding to single plucked string of Tamboura are mapped on the keyboard from G#3 through G#6, with the range C#5 through G#5 corresponding to the middle octave (Madhya Saptak). Continuous resonating drones are mapped onto the MIDI keys from G2 through G3 (C#3 = middle octave C#).

The rest of the MIDI keyboard (not shown in the figure below) is not mapped to any sound.

MIDI Key Map for Tamboura
MIDI keys G2 through G#6


MIDI Key Mapping

MIDI Key Map for Tanpura (patch 11)

The following figure shows the mapping of various Tanpura sounds onto the MIDI keyboard. The sounds corresponding to single plucked string of Tanpura are mapped on the keyboard from G#3 through G#5, with the range C#5 through G#5 corresponding to the middle octave (Madhya Saptak). A single resonating string sound is mapped onto the MIDI keys from C#1 through F#2, whereas continuous drones are mapped onto the MIDI keys from G2 through G3.

The rest of the MIDI keyboard (not shown in the figure below) is not mapped to any sound.

MIDI Key Map for Tanpura
MIDI keys C#1 through G#5